unit Unit1;

interface

uses Windows, Messages, SysUtils, Classes, Controls, Zlibexgz, {http://www.zlib.net/}
     Forms, WinSock, StdCtrls, Registry, ComCtrls, ComObj, mmsystem;

type
  TForm1 = class(TForm)
    Button2: TButton;
    CheckBox1: TCheckBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;

  item = record
   title:string;
   auth:string;
   ans:string;
   like:string;
   view:string;
   page:string;
   URL:string;
   num:string;
  end;

const
  Key = 'SOFTWARE\GotAIReader\Options';

var
  Form1: TForm1;
  client:TSocket;
  WSAData: TWSAData;
  INIReg:TRegInifile;
  forum: array of item;
  MsExcel: Variant;
  timer,event1:thandle;

implementation

{$R *.dfm}

procedure CallBackTime(TimerID, uMessage: UINT;dwUser, dw1, dw2: DWORD) stdcall;
begin
 SetEvent(event1);
end;

procedure Wait(duration:integer);
 var n:integer;
begin
 for n:=0 to duration do begin
  Timer:=timeSetEvent(5,5,@CallBackTime,0,TIME_ONESHOT);
  WaitForSingleObject(event1, infinite);
  timeKillEvent(Timer);
 end; 
end;

function CheckData(Sock: TSocket): boolean;
var
  Res,Count: integer;
begin
  Res:=WinSock.ioctlsocket(Sock,FIONREAD,Longint(Count));
  if Res=SOCKET_ERROR then raise Exception.Create(Format('Error %d while receiving data: %s',[WSAGetLastError,SysErrorMessage(WSAGetLastError)]));
  Result:=Count>0;
end;

function ReceiveData(Sock: TSocket; var P: Pointer): integer;
var
  Res: integer;
begin
  P:=nil;
  Result:=0;
  repeat
    ReallocMem(P,Result+3072);
    Res:=WinSock.recv(Sock,Pointer(PChar(P)+Result)^,3072,0);
    if Res=SOCKET_ERROR then raise Exception.Create(Format('Error %d while receiving data: %s',[WSAGetLastError,SysErrorMessage(WSAGetLastError)])) else
      if Res=0 then break else inc(Result,Res);
    sleep(200);
    Application.ProcessMessages;
    if not CheckData(Sock) or Application.Terminated then break;
  until FALSE;
  ReallocMem(P,Result);
end;

function ReceiveString(Sock: TSocket): string;
var
  P: Pointer;
  Sz: integer;
begin
  Sz:=ReceiveData(Sock,P);
  if Sz>0 then try
    SetLength(Result,Sz);
    Move(P^,PChar(Result)^,Sz);
  finally
    FreeMem(P,Sz);
  end;
end;

procedure SendData(Sock: TSocket; const Buf; Sz: integer);
 var Res,Sent: integer;
begin
 Sent:=0;
 while (Sent<Sz) and not Application.Terminated do begin
  Res:=WinSock.send(Sock,(PChar(@Buf)+Sent)^,Sz-Sent,0);
  if Res<>SOCKET_ERROR then inc(Sent,Res) else break;
 end;
end;

function IPToHost(IPAddr : String): String;
var
 SockAddrIn: TSockAddrIn;
 HostEnt: PHostEnt;
begin
 SockAddrIn.sin_addr.s_addr:= inet_addr(PChar(IPAddr));
 HostEnt:= gethostbyaddr(@SockAddrIn.sin_addr.S_addr, 4, AF_INET);
 if HostEnt<>nil then
  begin
   result:=string(Hostent^.h_name);
  end
 else result:='';
end;

function HostToIP(Name: string; var Ip: string): Boolean;
var
 hostName:array [0..255] of char;
 hostEnt:PHostEnt;
 addr:PChar;
begin
 gethostname (hostName, sizeof (hostName));
 StrPCopy(hostName, Name);
 hostEnt := gethostbyname (hostName);
 if Assigned (hostEnt) then
  if Assigned (hostEnt^.h_addr_list) then begin
    addr := hostEnt^.h_addr_list^;
    if addr<>nil then begin
      IP := Format ('%d.%d.%d.%d', [byte (addr [0]),byte (addr [1]), byte (addr [2]), byte (addr [3])]);
      Result := True;
    end else Result := False;
   end else Result := False
 else Result := False;
end;

function FindFromPos(Substr,s:string;Pos:integer=1):integer;
 var i,len1,len2:integer;
     trigger:boolean;
begin
 result:=0;
 len1:=length(s);
 if len1<pos then exit;
 len2:=length(substr);
 dec(pos);
 repeat begin
  trigger:=true;
  for i:=1 to len2 do if s[pos+i]<>substr[i] then begin trigger:=false; break; end;
  inc(pos);
  if trigger then begin result:=pos; exit; end;
 end until pos=len1;
end;

function ConnectAndGet(str:string):string;
 var temp:string;
 Addr:TSockAddr;
begin
 client:=Socket(AF_INET,SOCK_STREAM,0);
 if client<>INVALID_SOCKET then begin
  Addr.sin_family:=AF_Inet;
  if form1.checkbox1.Checked then begin // 
   Addr.sin_port:=HToNS(strtoint(form1.edit3.Text));
   if IPToHost(form1.edit2.Text)<>'' then
    Addr.sin_addr.S_addr:=Inet_Addr(pchar(form1.edit2.Text)) else
    Addr.sin_addr.S_addr:=Inet_Addr('0');
  end else begin                // 
   Addr.sin_port:=HToNS(80);
   HostToIP('www.gotai.net',temp);
   Addr.sin_addr.S_addr:=Inet_Addr(pchar(temp));
  end;

  FillChar(Addr.Sin_Zero,SizeOf(Addr.Sin_Zero),0);
  if Connect(client,Addr,SizeOf(TSockAddr))<>0 then
     form1.Caption:='   !'
   else begin
    application.ProcessMessages;
    SendData(client,PChar(str)^,Length(str)); //  
    result:=ReceiveString(client);
    Shutdown(client,SD_Both);
    Closesocket(client);
   end;
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var temp,t:string;
 buf:string;
 i,j,k,l:integer;
begin
 button2.Enabled:=false;
 forum:=nil; //    
 form1.Caption:='...';
 temp:='GET /forum/Default.aspx?threadspage=1 HTTP/1.1'+#13#10+   //  ,     
 'Host: www.gotai.net'+#13#10+
 'User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:47.0) Gecko/20100101 Firefox/47.0'+#13#10+
 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'+#13#10+
 'Accept-Language: ru-RU,ru;q=0.8,en-US;q=0.5,en;q=0.3'+#13#10+
 'Accept-Encoding: gzip, deflate'+#13#10+
 'Referer: http://www.gotai.net/forum/'+#13#10+
 'Connection: keep-alive'+#13#10+
 'Cache-Control: max-age=0'+#13#10#13#10;
 buf:=ConnectAndGet(temp);
 if buf<>'' then begin
  delete(buf,1,pos(#13#10#13#10,buf)+3);  // ,     
  buf:=GZDecompressStr(buf);     // gzip
  t:='0';
  j:=pos('<td align="left" width="50%" class="Normal"><b>&nbsp;',buf);
  i:=findfrompos('(',buf,j);  //  
  j:=findfrompos(')',buf,j);
  t:=copy(buf,i+1,j-i-1);
  if strtoint(t)>0 then begin
   form1.Caption:=' : 0  '+t;
   application.ProcessMessages;

   for k:=1 to strtoint(t) do begin
    temp:='GET /forum/Default.aspx?threadspage='+inttostr(k)+' HTTP/1.1'+#13#10+
    'Host: www.gotai.net'+#13#10+
    'User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:47.0) Gecko/20100101 Firefox/47.0'+#13#10+
    'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'+#13#10+
    'Accept-Language: ru-RU,ru;q=0.8,en-US;q=0.5,en;q=0.3'+#13#10+
    'Accept-Encoding: gzip, deflate'+#13#10+
    'Referer: http://www.gotai.net/forum/'+#13#10+
    'Connection: keep-alive'+#13#10+
    'Cache-Control: max-age=0'+#13#10#13#10;

    buf:='';
    repeat
     buf:=ConnectAndGet(temp)
    until buf<>'';
    delete(buf,1,pos(#13#10#13#10,buf)+3); // ,     
   // Wait(5000); // 
    buf:=GZDecompressStr(buf);             // gzip

    l:=0;
    repeat begin
     l:=findfrompos('" class="f">',buf,l+1);   //   
     if l<>0 then begin
      setlength(forum,length(forum)+1);
      i:=l;
      repeat
       dec(i);
      until buf[i]='=';
      forum[high(forum)].URL:='http://www.gotai.net/forum/Default.aspx?threadid='+copy(buf,i+1,l-i-1);
      forum[high(forum)].num:=copy(buf,i+1,(l-i-1) div 2);
      i:=findfrompos('</a>',buf,l);
      forum[high(forum)].title:=Utf8ToAnsi(copy(buf,l+12,i-l-12));

      i:=findfrompos('username',buf,i);
      i:=findfrompos('>',buf,i);
      j:=findfrompos('<',buf,i);
      forum[high(forum)].auth:=Utf8ToAnsi(copy(buf,i+1,j-i-1));

      j:=findfrompos('</td><td class="wsRowHighlight" align="center" width="50"><span class="Normal">',buf,j);
      i:=findfrompos('</span>',buf,j);
      forum[high(forum)].ans:=copy(buf,j+79,i-j-79);

      j:=findfrompos('</td><td class="wsRowHighlight" align="center" width="50"><span class="',buf,i);
      j:=findfrompos('">',buf,j+71);
      i:=findfrompos('</span>',buf,j);
      forum[high(forum)].like:=copy(buf,j+2,i-j-2);

      j:=findfrompos('</td><td class="wsRowHighlight" align="center" width="50"><span class="Normal">',buf,i);
      i:=findfrompos('</span>',buf,j);
      forum[high(forum)].view:=copy(buf,j+79,i-j-79);

      forum[high(forum)].page:=inttostr(k);
     end;
    end until l=0;

    form1.Caption:=' : '+inttostr(k)+'  '+t;
    Application.Title:='GotAI Reader '+inttostr(k)+'/'+t;    
    application.ProcessMessages;
   end;

   MsExcel:=CreateOleObject('Excel.Application');
   MsExcel.Workbooks.Add;
   form1.Caption:='...';
   application.ProcessMessages;
   for i:=0 to high(forum) do begin
    MsExcel.Cells[i+1, 1]:=forum[i].title;
    MsExcel.Cells[i+1, 2]:=forum[i].auth;
    MsExcel.Cells[i+1, 3]:=forum[i].ans;
    MsExcel.Cells[i+1, 4]:=forum[i].like;
    MsExcel.Cells[i+1, 5]:=forum[i].view;
    MsExcel.Cells[i+1, 6]:=forum[i].page;
    MsExcel.Cells[i+1, 7]:=forum[i].URL;
    MsExcel.Cells[i+1, 8]:=forum[i].num;
   end;
   MsExcel.Visible := True;
  end;
 end;
 form1.Caption:='!';
 Application.Title := 'GotAI Reader';
 button2.Enabled:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 if WSAStartUp($0101,WSAData)<>0 then MessageBox(form1.Handle,' ','Error',MB_OK);
 INIReg:=TRegInifile.Create;
 checkbox1.Checked:=INIReg.ReadBool(Key,'UseProxy',false);
 edit2.Text:=INIReg.ReadString(Key,'Proxy','10.10.2.3');
 edit3.Text:=INIReg.ReadString(Key,'Port','3128');
 form1.Top:=INIReg.ReadInteger(Key,'Top',(screen.Height div 2)-form1.Height div 2);
 form1.Left:=INIReg.ReadInteger(Key,'Left',(screen.Width div 2)-form1.Width div 2);
 INIReg.CloseKey;
 INIReg.Free;
 CheckBox1Click(nil);
 event1:=CreateEvent(nil, false, false, nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 WSACleanup;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if CheckBox1.Checked then begin
  edit2.Visible:=true;
  edit3.Visible:=true;
  label1.Visible:=true;
 end else begin
  edit2.Visible:=false;
  edit3.Visible:=false;
  label1.Visible:=false;
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 INIReg:=TRegInifile.Create;
  INIReg.WriteBool(Key,'UseProxy',checkbox1.Checked);
  INIReg.WriteString(Key,'Proxy',edit2.Text);
  INIReg.WriteString(Key,'Port',edit3.Text);
  INIReg.WriteInteger(Key,'Top',form1.Top);
  INIReg.WriteInteger(Key,'Left',form1.Left);
 INIReg.CloseKey;
 INIReg.Free;
 CloseHandle(event1);
end;

end.
